/***************************************************************************
                          constants.h  -  description
                             -------------------
    begin                : Thu Apr 11 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONSTANTS_H
#define CONSTANTS_H

//#include "memwatch.h"

#define RNA   0
#define DNA   1

// change these if necessary
#define MAXSLEN         4500  // maximum of total sequence length
#define MAXENERGY       0            // the maximum energy that this program returns (usually 0)
#define MAX_BRANCHES    50   // maximum # of branches in multiloops
#define MAXSUBSTR       1000 //10000     //200

#define MAXNUMPARAMS    8000     // max # of thermodynamic parameters
#define MAXPNAME        50        // max length of a parameter name

//for MultiFold
#define MAXNUMSEQ      50

#define A               0
#define C               1
#define G               2
#define U               3
#define T               3

// do not change
#define INF             1600000      // a very big value (infinity)
#define NUCL            4            // number of nucleotides: 4: A, C, G, T
#define MAXLOOP         30           // max loop for which the size of the loop is penalized - see loop.dat
#define MAXTRILOOPNO    100
#define MAXTLOOPNO      400
#define EPSILON         0.0001       // a very small value
#define TURN            3            // the minimum number of free bases in a hairpin loop


#define NONE            'N'         // no structure
#define HAIRP           'H'         // closes a hairpin loop
#define STACK           'S'         // closes a stacked pair
#define INTER           'I'         // closes an internal loop
#define MULTI           'M'         // closes a regular multi-loop
#define MULTI_LINK      'O'         // closes a special multi-loop

#define M_WM            'B'         // closes a regular partial multi-loop
#define M_WM_LINK       'C'         // closes a special partial multi-loop

#define FREE            'W'         // this base is free to be paired or unpaired to other base
#define LOOP            'V'         // closes a loop

#define M_FM            'F'         // regular FM from the multiloop decomposition of Wutchy et al 
#define M_FM1           'A'         // regular FM1 from the multiloop decomposition of Wutchy et al

#define M_FM_LINK       'P'         // special FM adapted from FM = the multiloop decomposition of Wutchy et al
#define M_FM1_LINK      'Q'         // special FM1 adapted from FM1 = the multiloop decomposition of Wutchy et al


#endif

